/*
    This file is part of Escota.

    Escota is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Escota is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Escota.  If not, see <http://www.gnu.org/licenses/>.
 */

package escota;

import escota.flickr.Conexion;
import escota.utils.BrowserLaunch;
import escota.utils.Log;
import java.io.IOException;
import java.util.Iterator;
import org.jdesktop.application.Action;

/**
 *
 * @author AGuS
 */
public class EscotaFlickrLogin extends javax.swing.JDialog {

    /** Creates new form EscotaFlickrLogin */
    public EscotaFlickrLogin(java.awt.Frame parent, boolean modal, Conexion conexion, EscotaView ev) {
        super(parent, modal);
        initComponents();
        this.ev = ev;
        try
        {
            Iterator it = Conexion.retriveAllUserStored().iterator();
            if(it.hasNext())
            {
                while(it.hasNext())
                {
                    jComboBox1.addItem(it.next());
                }
            }
            else
            {
                jLabel1.setEnabled(false);
                jButton1.setEnabled(false);
                jComboBox1.setEnabled(false);
            }
        }
        catch(IOException io)
        {
            dispose();
            Log.error("Error retriveing all users stored", io);
            ev.showErrorMessage("Error retriveing all users stored", true);
        }
        this.conexion=conexion;
    }
    @Action public void closeLoginBox() {
        dispose();
    }
    private void setEnable(boolean enable)
    {
        this.jButton1.setEnabled(enable);
        this.jButton2.setEnabled(enable);
        this.jComboBox1.setEnabled(enable);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jButton1 = new javax.swing.JButton();
        jComboBox1 = new javax.swing.JComboBox();
        jLabel1 = new javax.swing.JLabel();
        jButton2 = new javax.swing.JButton();
        jSeparator1 = new javax.swing.JSeparator();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(escota.EscotaApp.class).getContext().getResourceMap(EscotaFlickrLogin.class);
        setTitle(resourceMap.getString("Form.title")); // NOI18N
        setName("Form"); // NOI18N
        setResizable(false);

        jButton1.setText(resourceMap.getString("jButton1.text")); // NOI18N
        jButton1.setName("jButton1"); // NOI18N
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        jComboBox1.setName("jComboBox1"); // NOI18N

        jLabel1.setText(resourceMap.getString("jLabel1.text")); // NOI18N
        jLabel1.setName("jLabel1"); // NOI18N

        jButton2.setText(resourceMap.getString("jButton2.text")); // NOI18N
        jButton2.setName("jButton2"); // NOI18N
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });

        jSeparator1.setName("jSeparator1"); // NOI18N

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                    .addComponent(jButton1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jLabel1, javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jSeparator1, javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jComboBox1, javax.swing.GroupLayout.Alignment.LEADING, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jButton2, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 174, Short.MAX_VALUE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel1)
                .addGap(18, 18, 18)
                .addComponent(jComboBox1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(jButton1)
                .addGap(18, 18, 18)
                .addComponent(jSeparator1, javax.swing.GroupLayout.PREFERRED_SIZE, 10, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jButton2)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        jLabel1.setText("Prueba redonda");
        String nsid = "";
        try
        {
            nsid = Conexion.getNSID(jComboBox1.getSelectedItem().toString());
            conexion.setNsid(nsid);
            conexion.setStep2(false);
            conexion.setCanAuth(true);
            
            closeLoginBox();
        }
        catch(Exception e)
        {
            Log.error("Error getting a nsid from a user name", e);
            ev.showErrorMessage("Error getting a nsid from a user name", true);
        }
    }//GEN-LAST:event_jButton1ActionPerformed

    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        String secondText = "Click when you login in flickr";       
        if(evt.getActionCommand().equals("Auth a new user"))
        {
            this.jComboBox1.setEnabled(false);
            this.jButton1.setEnabled(false);
            this.jLabel1.setEnabled(false);
            try
            {
                url = conexion.authorizeStep1();
                BrowserLaunch.openURL(url);
                this.jButton2.setText(secondText);
            }
            catch(Exception e)
            {
                Log.error("Error launching a webbrowser", e);
                ev.showErrorMessage("Error launching a webbrowser", true);
            }
        }
        else if (evt.getActionCommand().equals(secondText))
        {
            try
            {
                conexion.setStep2(true);
                conexion.setCanAuth(true);
                closeLoginBox();
            }
            catch(Exception e)
            {
                BrowserLaunch.openURL(url);
                Log.error("Error authorizing a user", e);
                ev.showErrorMessage("Error authorizing a user", true);
            }
        }
    }//GEN-LAST:event_jButton2ActionPerformed


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JComboBox jComboBox1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JSeparator jSeparator1;
    // End of variables declaration//GEN-END:variables

    private Conexion conexion=null;
    private String url = "";
    private EscotaView ev;
}
