/*
    This file is part of Escota.

    Escota is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Escota is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Escota.  If not, see <http://www.gnu.org/licenses/>.
 */
package escota;

import com.aetrion.flickr.FlickrException;
import com.aetrion.flickr.photos.Photo;
import com.aetrion.flickr.photos.PhotoList;
import escota.flickr.Conexion;
import escota.flickr.GenerateTasksThread;
import escota.flickr.Rule;
import escota.flickr.TaskQueue;
import escota.utils.BrowserLaunch;
import escota.utils.Log;
import java.util.Iterator;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.DefaultListModel;

/**
 *
 * @author AGuS
 */
public class EscotaPhotoChooser extends javax.swing.JDialog {

    /** Creates new form EscotaPhotoChooser */
    public EscotaPhotoChooser(java.awt.Frame parent, Conexion conexion, Rule rule, TaskQueue taskQueue, EscotaView ev) {
        super(parent, true);
        initComponents();
        this.conexion = conexion;
        this.rule = rule;
        this.taskQueue = taskQueue;
        this.ev = ev;

        DefaultListModel model = new DefaultListModel();


        Iterator iter = conexion.getAllPhotos().keySet().iterator();
        while (iter.hasNext()) {
            String s = (String) iter.next();
            model.addElement(s);
        }
        jXList1.setModel(model);
        if(!model.isEmpty())
            jXList1.setSelectedIndex(0);
  
    }
    public void close()
    {
        dispose();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        jXList1 = new org.jdesktop.swingx.JXList();
        jButton1 = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jScrollPane2 = new javax.swing.JScrollPane();
        jXList2 = new org.jdesktop.swingx.JXList();
        jButton2 = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(escota.EscotaApp.class).getContext().getResourceMap(EscotaPhotoChooser.class);
        setTitle(resourceMap.getString("Form.title")); // NOI18N
        setMinimumSize(new java.awt.Dimension(550, 550));
        setName("Form"); // NOI18N

        jScrollPane1.setName("jScrollPane1"); // NOI18N

        jXList1.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        jXList1.setName("jXList1"); // NOI18N
        jXList1.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                jXList1ValueChanged(evt);
            }
        });
        jScrollPane1.setViewportView(jXList1);

        jButton1.setText(resourceMap.getString("jButton1.text")); // NOI18N
        jButton1.setEnabled(false);
        jButton1.setName("jButton1"); // NOI18N
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        jLabel1.setText(resourceMap.getString("jLabel1.text")); // NOI18N
        jLabel1.setName("jLabel1"); // NOI18N

        jLabel2.setText(resourceMap.getString("jLabel2.text")); // NOI18N
        jLabel2.setName("jLabel2"); // NOI18N

        jScrollPane2.setName("jScrollPane2"); // NOI18N

        jXList2.setName("jXList2"); // NOI18N
        jXList2.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jXList2MouseClicked(evt);
            }
        });
        jXList2.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                jXList2ValueChanged(evt);
            }
        });
        jScrollPane2.setViewportView(jXList2);

        jButton2.setText(resourceMap.getString("jButton2.text")); // NOI18N
        jButton2.setName("jButton2"); // NOI18N
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 151, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel1))
                        .addGap(10, 10, 10)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createSequentialGroup()
                                .addGap(10, 10, 10)
                                .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 359, Short.MAX_VALUE))
                            .addComponent(jLabel2)))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addComponent(jButton2)
                        .addGap(18, 18, 18)
                        .addComponent(jButton1)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(jLabel2))
                .addGap(12, 12, 12)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 355, Short.MAX_VALUE)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 355, Short.MAX_VALUE))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButton1)
                    .addComponent(jButton2))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jXList1ValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_jXList1ValueChanged
        String selectedSet = (String)jXList1.getSelectedValue();
        final PhotoList photoList = (PhotoList) conexion.getAllPhotos().get(selectedSet);

        DefaultListModel model = new DefaultListModel();
        
        Iterator it = photoList.iterator();
        while(it.hasNext())
        {
            model.addElement(it.next());
        }

        jXList2.setModel(model);
        jXList2.setCellRenderer(new IconListRenderer(selectedSet, photoList));

    }//GEN-LAST:event_jXList1ValueChanged

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        String selectedSet = (String)jXList1.getSelectedValue();
        int[] selectedIndices = jXList2.getSelectedIndices();


        ev.setNullTaskGenerator();
        new GenerateTasksThread( selectedSet, selectedIndices, conexion, rule, taskQueue,ev).start();
        ev.showTaskGenerator();
        
    }//GEN-LAST:event_jButton1ActionPerformed

    private void jXList2ValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_jXList2ValueChanged
        if(jXList2.getSelectedIndices().length<1)
            jButton1.setEnabled(false);
        else
            jButton1.setEnabled(true);
    }//GEN-LAST:event_jXList2ValueChanged

    private void jXList2MouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_jXList2MouseClicked
        // TODO add your handling code here:
        Log.debug("clicked " + evt.getClickCount());
        if(evt.getClickCount()>1 && jXList2.getSelectedIndex() != -1)
        {
            String selectedSet = (String)jXList1.getSelectedValue();
            final PhotoList photoList = (PhotoList) conexion.getAllPhotos().get(selectedSet);
            Photo photo = (Photo) photoList.get(jXList2.getSelectedIndex());
            BrowserLaunch.openURL(photo.getUrl());
        }
    }//GEN-LAST:event_jXList2MouseClicked

    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        // TODO add your handling code here:
        ev.setNullTaskGenerator();
        new GenerateTasksThread( null, null, conexion, rule, taskQueue,ev).start();
        ev.showTaskGenerator();
    }//GEN-LAST:event_jButton2ActionPerformed

    /**
    * @param args the command line arguments
    */


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private org.jdesktop.swingx.JXList jXList1;
    private org.jdesktop.swingx.JXList jXList2;
    // End of variables declaration//GEN-END:variables

    private Conexion conexion;
    private Rule rule;
    private TaskQueue taskQueue;
    private EscotaView ev;
}
