/*
    This file is part of Escota.

    Escota is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Escota is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Escota.  If not, see <http://www.gnu.org/licenses/>.
 */

package escota;

import com.aetrion.flickr.photos.Photo;
import com.aetrion.flickr.photos.PhotoList;
import java.awt.Component;
import java.io.File;
import javax.swing.DefaultListCellRenderer;
import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JList;


public class IconListRenderer extends DefaultListCellRenderer {

    private PhotoList photoList;
    private String selectedSet;

	public IconListRenderer(String selectedSet,PhotoList photoList) {
        this.photoList = photoList;
        this.selectedSet = selectedSet;
	}

	@Override
	public Component getListCellRendererComponent(
		JList list, Object value, int index,
		boolean isSelected, boolean cellHasFocus) {

        Photo photo = (Photo) photoList.get(index);

		// Get the renderer component from parent class

		JLabel label =
			(JLabel) super.getListCellRendererComponent(list,
				value, index, isSelected, cellHasFocus);

        label.setText(photo.getTitle());

		// Get icon to use for the list item value
        String filePath = System.getProperty("user.home") + File.separatorChar + ".escota" + File.separatorChar + "photos" + File.separatorChar + selectedSet + File.separatorChar + photo.getId() + ".jpg";

        ImageIcon icon = new ImageIcon(filePath);
        label.setIcon(icon);

		return label;
	}
}
