/*
    This file is part of Escota.

    Escota is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Escota is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Escota.  If not, see <http://www.gnu.org/licenses/>.
 */

package escota.flickr;

import escota.EscotaTaskExecutor;
import escota.EscotaView;
import escota.utils.Log;

/**
 *
 * @author AGuS
 */
public class ExecuteTasksThread extends Thread {
    public ExecuteTasksThread(EscotaView ev)
    {
        super();
        this.ev = ev;
        
    }

    @Override
    public void run()
    {
        
        try {
            te = ev.getTaskExecutor();
            
            while (te == null) {
                sleep(1000);
                te = ev.getTaskExecutor();
            }
            ev.getTaskQueue().executeTasks(ev.getConexion(),te);
        } catch (Exception ex) {
            Log.error("Error executing tasks", ex);
            ev.showErrorMessage("Error executing tasks", true);
        }
    }
    private EscotaView ev;
    private EscotaTaskExecutor te;
}
