/*
    This file is part of Escota.

    Escota is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Escota is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Escota.  If not, see <http://www.gnu.org/licenses/>.
 */

package escota.utils;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;

/**
 *
 * @author AGuS
 */
public class Log {
    private static int mode = 3;
    private static int point = 0;
    public static void setErrorMode()
    {
        mode = 3;
    }
    public static void setDebugMode()
    {
        mode = 2;
    }
    public static void setWarnMode()
    {
        mode = 2;
    }
    public static void disable()
    {
        mode = 0;
    }
    public static DateFormat f = new SimpleDateFormat("dd/MM/yy HH:mm:ss");

    public static void error(String text, Exception ex)
    {
        if(mode>2)
        {
            Date now = new Date();
            ex.printStackTrace();
        }
    }
    public static void debug(String text)
    {
        if(mode>1)
        {
            Date now = new Date();
            System.out.println( f.format(now) + " [Debug] " + text);
        }
    }
    public static void warn(String text)
    {
        if(mode>0)
        {
            Date now = new Date();
            System.out.println( f.format(now) + " [Error] " + text);
        }
    }
    public static void point()
    {
        debug("Hello " + Integer.toString(point));
        point++;
    }
}
